'
' -----------------------------------------------------------------------------
' RAPIDQ LONG EXE and TINY EXE Compiler          Jacques     october 22th, 2010
' Compare RapidQ32/CC.Lib and RapidQ32/CC.Dll  Speed
' DLL interpretor is ~twice faster than LIB interpretor
' -----------------------------------------------------------------------------
''pre cmd con tiny run exe kill 'opt 640.Ico 'enc 'upx 'BK 'LaunBas output 'adddll
DefStr BuildCount = "0.011" ''pre + 0.001 3
''pre end
'
Print  ' Forces a Console
'
$INCLUDE "QiniMe.Inc"
$INCLUDE "QREDEX.INC"
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
$OPTION ICON "Clock5.ICO"
$RESOURCE FORM_ICO AS "Clock5.Ico"
'
Declare Function RQ_ExecuteFileCon Lib "RapidQCC.Dll" Alias "RQ_ExecuteFile" _
                         (Filename As String, Commands As Long, Count As Long) As Long
Declare Function RQ_ExecuteFileGui Lib "RapidQ32.Dll" Alias "RQ_ExecuteFile" _
                         (Filename As String, Commands As Long, Count As Long) As Long
'
Declare Sub OnClose_frmCompileRQ
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
Declare Sub OnClic_btnRefresh
Declare Sub OnChange_Directory
Declare Sub OnChange_edtFileFilter (Key As Long)
Declare Sub OnDblClick_lstFiles
'
Dim myIni As QIni
Create frmCompileRQ As QForm
    Center
    Width = Val(myIni.Read ("FormWidth", "1200"))
    height = Val(myIni.Read ("FormHeight", "800"))
    Caption = "frmCompileRQ" & " V" & BuildCount
    AutoScroll = False
    IcoHandle = FORM_ICO
    OnClose = OnClose_frmCompileRQ
    Create pnlRight As QPanel
        Width = Val(myIni.Read("pnlRightWidth", Str$(frmCompileRQ.ClientWidth * 0.25)))
        Align = alRight
        Create dirTree AS QDirTree
            Height =  Val(myIni.Read("dirTreeHeight", Str$(frmCompileRQ.ClientHeight/2)))
            Align = alTop
            Font.Size = 10
            InitialDir = CURDIR$
            OnChange = OnChange_Directory
        End Create
        Create pnlRightTop As QPanel
            Height = 75
            Align = alTop
            Create btnRefresh AS QButton
                Height = 25
                Align = alTop
                Font.Bold = True
                Font.Size = 12
                Caption = "&REFRESH"
                OnClick = OnClic_btnRefresh
            End Create
            Create pnlRightTop_up As QPanel
                Height = 25
                Align = alTop
                Create lblMyLabel As QLabel
                    Height = 25
                    align = alLeft
                    Font.Size = 12
                    Caption = " Files Filter : "
                End Create
                Create edtFileFilter AS QEdit
                    align = alClient
                    Width = 60
                    Height = 25
                    Font.Size = 12
                    Font.Bold = True
                    Text =  myIni.Read ("FileFilter", "*.Bas;*.Rqw;*.Rqb;*.Inc") ' "*.*"
                    OnChange = OnChange_edtFileFilter
                    ShowHint = True
                    Hint = "Filter For Files, WildCards Allowed (*, ?)"
                End Create
            End Create
            Create edtDirectory AS QEdit
                Height = 25
                align = alClient
                Font.Bold = True
            End Create
        End Create
        Create Splitter_H AS QSPLITTER
            Align = alTop
            Cursor = crVSplit
            MinSize = 100
            Height = 8
            Color = &H00FF00
        End Create
        Create lstFiles AS QFileListBox
            Height = 300
            Align = alClient
            Font.Size = 10
            Mask = "*.*"
            OnDblClick = OnDblClick_lstFiles
        End Create
    End Create
    Create Splitter_V AS QSPLITTER
        Width = 8
        Align = alRight
        Cursor = crHSplit
        MinSize = 100
        Color = &HFF0000
    End Create
    Create pnlLeft As QPanel
        Align = alClient
        Create rchWin AS QRichEdit
            Align = alClient
            Font.Name = "courier"
            Font.Size = 12
            Font.Color = &H800000
            Font.Bold = True
            ReadOnly = False
            WordWrap = False
            ScrollBars = ssBoth
            HideSelection = False
            PlainText = True
            ExtendSizeLimit
        End Create
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuCompileLong AS QMENUITEM
            Caption = "Compile &Long Exe"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuCompileTinyGui AS QMENUITEM
            Caption = "Compile &Tiny GUI Exe"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuCompileTinyCon AS QMENUITEM
            Caption = "Compile &Tiny CON Exe"
            OnClick = OnClic_AnyMenu
        End Create
        Create mnuClear AS QMENUITEM
            Caption = "  &CLEAR"
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
' ---------------------------------------------------------------------
' To Correct RapidQ Minimizing on the DeskTop
' -------------------------------------------
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, nIndex AS LONG, dwNewLong AS LONG) AS LONG
SUB MinSet (fhand as integer, gwl_hand as integer, hwnd as integer, apphand as integer)
    setwindowlong(fhand, Gwl_Hand, hwnd)
    setwindowlong(apphand, GWL_Hand, fhand)
End SUB
MinSet(frmCompileRQ.handle, -8, 0, application.handle)
' ---------------------------------------------------------------------
DefStr sNowDir
DefStr sSelPath = "", sSelFile = "", sSelPathFile = "", sSelFileNoExt = "", sSelExt = ""
DefStr sAppDir = Command$(0) - Application.ExeName
sNowDir = myIni.Read ("InitialDir", sAppDir)
edtDirectory.Text = sNowDir
dirTree.InitialDir = sNowDir
ChDir sNowDir
lstFiles.Directory = sNowDir
DefInt flagMenuBusy = False
lstFiles.Mask = edtFileFilter.Text
lstFiles.Update
'
' *************************************
Declare Function SHL_GetVersion Lib "kernel32" Alias "GetVersion" () As Long
DefInt SHL_OS_Version = SHL_GetVersion
If (SHL_OS_Version And 255) < 5 Then frmCompileRQ.Show
' *************************************
'
DefStr sError = ""
If FileExists ("Rc.Exe")       = 0 Then sError = sError & "\nCopy   Rc.Exe       in Me directory"
If FileExists ("RapidQ.Inc")   = 0 Then sError = sError & "\nCopy   Rapdq.Inc    in Me directory"
If FileExists ("RapidQ32.Dll") = 0 Then sError = sError & "\nCopy   Rapdq32.Dll  in Me directory"
If FileExists ("RapidQCC.Dll") = 0 Then sError = sError & "\nCopy   RapdqCC.Dll  in Me directory"
If FileExists ("RapidQ32.Lib") = 0 Then sError = sError & "\nCopy   Rapdq32.Lib  in Me directory"
If FileExists ("RapidQCC.Lib") = 0 Then sError = sError & "\nCopy   RapdqCC.Lib  in Me directory"
If sError <> "" Then
    ShowMessage ("You must copy the following files in my Directory\n\n" & sError & "\n\nCopy the missing files and Retry\n\n        I will close")
    frmCompileRQ.Close
End If
'
'
' *************************************
If (SHL_OS_Version And 255) < 5 Then frmCompileRQ.Visible = False
frmCompileRQ.ShowModal
' *************************************
'
Sub OnDblClick_lstFiles
    DefInt iPtr
    sSelFile = lstFiles.Item(lstFiles.ItemIndex)
    sSelPath = dirTree.Directory
    sSelPathFile = sSelPath & sSelFile
    ' *EXT  includes the "." dot
    iPtr = RInstr (sSelFile, ".")
    If iPtr = 0 Then
        sSelExt = ""
        sSelFileNoExt = sSelFile
    Else
        sSelExt = Mid$(sSelFile, iPtr)
        sSelFileNoExt = Left$(sSelFile, iPtr - 1)
    End If
'    ShowMessage ("      sSelExt : " & sSelExt _
'             & "\nsSelFileNoExt : " & sSelFileNoExt _
'             & "\n     sSelFile : " & sSelFile _
'             & "\n     sSelPath : " & sSelPath _
'             & "\n sSelPathFile : " & sSelPathFile)
    rchWin.LoadFromFile (sSelPathFile)
End sub
'
Sub OnClic_AnyMenu (Sender)
    DefStr sFile, sShell
    DefStr sExeName = ""
    DefStr sBcName = ""
    DefInt N, iLen, flagSpace, iDir = 0, iShell
    Dim slDump As QStringList
    Dim fExe As QFileStream
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    If sSelFile = "" Then
        ShowMessage "No RapidQ File Selected\n\n    ***  Nothing Done  ***"
        flagMenuBusy = False
        Exit Sub
    End If
    sExeName = sSelFileNoExt & ".exe"
    sBcName = sSelFileNoExt & ".Bc"
    If fExe.Open (sExeName, fmCreate) = 0 Then
        ShowMessage (sExeName & "  Already Running\n\nClose " & sExeName & "\n\n And Retry to Compile")
        fExe.Close
        flagMenuBusy = False
        Exit Sub
    End If
    fExe.Close
    DoEvents
    Select Case Sender.Handle
'
' Compile Stand Alone Long Executable and Excecute
' ------------------------------------------------
'
        Case mnuCompileLong.Handle
            Kill sSelFile
            Kill "Dump.$$$"
            slDump.Clear
            While FileExists (sSelFile) <> 0
                DoEvents
            Wend
            rchWin.SaveToFile (sSelFile)
            '
            Kill sExeName
            While FileExists (sExeName) <> 0
                DoEvents
            Wend
            sShell = "RC.EXE -r -o " & "\"" & sSelFile & "\""
            Shell sShell
            While FileExists ("Dump.$$$") = 0
                DoEvents
            Wend
            Doevents
            slDump.LoadFromFile ("Dump.$$$")
            If Instr(slDump.Text, "Compile time") <> 0 Then
                While FileExists (sExeName) = 0
                    DoEvents
                Wend
                DoEvents
                ' ShowMessage (" ***  OK :  " & sSelFile & "  compiled  to  " & sExeName)
                iShell = Shell (sExeName, 1)
            Else
                ShowMessage (slDump.Text)
            End If
'
' Compile Tiny ByteCode and Execute
' ---------------------------------
'
        Case mnuCompileTinyGui.Handle, mnuCompileTinyCon.Handle
            Kill sSelFile
            Kill "Dump.$$$"
            slDump.Clear
            While FileExists (sSelFile) <> 0
                DoEvents
            Wend
            rchWin.SaveToFile (sSelFile)
            '
            Kill sExeName
            While FileExists (sExeName) <> 0
                DoEvents
            Wend
            '
            Kill sBcName
            While FileExists (sBcName) <> 0
                DoEvents
            Wend
            '
            sShell = "RC.EXE -r -o -b " & "\"" & sSelFile & "\""
            Shell sShell
            While FileExists ("Dump.$$$") = 0
                DoEvents
            Wend
            Doevents
            slDump.LoadFromFile ("Dump.$$$")
            If Instr(slDump.Text, "Compile time") <> 0 Then
                While FileExists (sBcName) = 0
                    DoEvents
                Wend
                DoEvents
                If Sender.Handle = mnuCompileTinyGui.Handle Then
                    RQ_ExecuteFileGui (sBcName, 0, 0)
                Else
                    RQ_ExecuteFileCon (sBcName, 0, 0)
                End If
            Else
                ShowMessage (slDump.Text)
            End If
        Case mnuClear.Handle
            rchWin.Clear
    End Select
    flagMenuBusy = False
End Sub
'
Sub OnChange_edtFileFilter (Key As Long)
'    If Key = 13 Then
        lstFiles.Mask = edtFileFilter.Text
        lstFiles.Update
'    End If
End sub
'
SUB OnChange_Directory
    sNowDir = DirTree.Directory
    edtDirectory.Text = sNowDir
    ChDir sNowDir
    lstFiles.Directory = sNowDir
End SUB
'
Sub OnClose_frmCompileRQ
    myIni.Write ("FormWidth", Str$(frmCompileRQ.Width))
    myIni.Write ("FormHeight", Str$(frmCompileRQ.Height))
    myIni.Write ("pnlRightWidth", Str$(pnlRight.Width))
    myIni.Write ("FileFilter", edtFileFilter.Text)
    myIni.Write ("dirTreeHeight", Str$(dirTree.Height))
    myIni.Write ("InitialDir", sNowDir)
    Application.Terminate
End Sub
'
Sub OnClic_btnRefresh
    lstFiles.Mask =  edtFileFilter.Text
    lstFiles.Update
    dirTree.Reload
End Sub
'
'
$IFDEF NEVERDEFINE       ' Results here

    BYTECODE LAUNCHED FROM RAPIDQ TIMES (.Dll interpretor)
    -----------------------------------
    Empty Loop Time :                          0.639750004  seconds

    Integer Mult Full Loop Time :              1.531124949
    Integer Mult without Loop For Next Time:   0.891374946  seconds

    Double Mult Full Loop Time :               1.452875018  seconds
    Double Mult without Loop For Next Time:    0.813125014  seconds

    GetTickCount Full Loop Time :              4.296750069  seconds
    GetTickCount without Loop For Next Time:   3.657000065  seconds

    Space$(50)  Full Loop Time :               1.671875000  seconds
    Space$(50)  without Loop For Next Time:    1.032124996  seconds

    Adding Strings Full Loop Time :            3.358999968  seconds
    Adding Strings without Loop For Next Time: 2.719249964  seconds

    Search String Full Loop Time :             2.686625004  seconds
    Search String without Loop For Next Time:  2.046875000  seconds


    USUAL LONG EXE TIMES  (.Lib interpretor)
    --------------------
    Empty Loop Time :                          1.312500000  seconds

    Integer Mult Full Loop Time :              3.328000069
    Integer Mult without Loop For Next Time:   2.015500069  seconds

    Double Mult Full Loop Time :               3.327874899  seconds
    Double Mult without Loop For Next Time:    2.015374899  seconds

    GetTickCount Full Loop Time :              6.093750000  seconds
    GetTickCount without Loop For Next Time:   4.781250000  seconds

    Space$(50)  Full Loop Time :               3.233999968  seconds
    Space$(50)  without Loop For Next Time:    1.921499968  seconds

    Adding Strings Full Loop Time :            5.702624798  seconds
    Adding Strings without Loop For Next Time: 4.390124798  seconds

    Search String Full Loop Time :             4.952499866  seconds
    Search String without Loop For Next Time:  3.639999866  seconds

$ENDIF
