'
' -----------------------------------------------------------------------------
' Speed Compare between RapidQ Interpretor in .Dll and in .Lib
' RapidQ Console Test Code                         	 Jacques  October 22th 2010
' -----------------------------------------------------------------------------
'
''pre cmd con tiny run exe kill opt DirIcon 'enc 'upx 'BK 'LaunBas 'output 'adddll
DefStr BuildCount = "0.017" ''pre + 0.001 3
''pre end
Cls ' Set RQPC Console Patch
SetConsoleTitle (Application.ExeName & "   V" & BuildCount)
'
$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
Declare Function GetTickCount Lib "kernel32" Alias "GetTickCount" () As Long
'
DefSng sngChronoRQ
DefSng sngChronoTotal = Timer
'
DefDbl dblArray (0 to 2) = {3.333, 3, 0}
DefDbl dbl1 = 3.333, dbl2 = 3, dbl3 = 0
DefInt i1 = 12345, i2 = 54321, i3
DefStr s1, s2, s3
'
DefInt RQ_LoopCount = 1000000           ' adjust this to your computer speed
'
' Empty Loops
' -----------
DefInt N
DefSng sngChronoEmptyRQ = Timer
	For N = 1 To RQ_LoopCount
	Next N
sngChronoEmptyRQ = Timer - sngChronoEmptyRQ
Print "    Empty Loop Time :                          ";sngChronoEmptyRQ;"  seconds"
'
' Integer Multiplication
' ----------------------
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
		i3 = i1 * i2
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    Integer Mult Full Loop Time :              ";sngChronoRQ
Print "    Integer Mult without Loop For Next Time:   ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
' Loop with Double Multiplications
' --------------------------------
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
	    dbl3 = dbl1 * dbl2
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    Double Mult Full Loop Time :               ";sngChronoRQ;"  seconds"
Print "    Double Mult without Loop For Next Time:    ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
' Api Call GetTickCount
' ---------------------
DefInt iGetTickCount
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
	    iGetTickCount = GetTickCount
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    GetTickCount Full Loop Time :              ";sngChronoRQ;"  seconds"
Print "    GetTickCount without Loop For Next Time:   ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
' Creating String With Space$
' ---------------------------
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
	    s1 = Space$(50)
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    Space$(50)  Full Loop Time :               ";sngChronoRQ;"  seconds"
Print "    Space$(50)  without Loop For Next Time:    ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
'
' Adding Strings
' --------------
s1 = "abcdef"
s2 = "ghijkl"
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
	    s3 = s1 + s2
        s3 = ""
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    Adding Strings Full Loop Time :            ";sngChronoRQ;"  seconds"
Print "    Adding Strings without Loop For Next Time: ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
' Search in String
' ----------------
s1 = "Rapid-Q is a programming language, a BASIC programming language to be precise. It is multiplatform, although not completely compatible in terms of the graphical interface"
s2 = "It is"
sngChronoRQ = Timer
	For N = 1 To RQ_LoopCount
	   i1 = Instr (s1, s2)
	Next N
sngChronoRQ = Timer - sngChronoRQ
Print
Print "    Search String Full Loop Time :             ";sngChronoRQ;"  seconds"
Print "    Search String without Loop For Next Time:  ";sngChronoRQ - sngChronoEmptyRQ;"  seconds"
'
' Total Code and Loops
' --------------------
sngChronoTotal = Timer - sngChronoTotal
Print
Print "Total Time : Code + Loops With For Next Time : ";sngChronoTotal;"  seconds"
'
' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
Input "\n       *** CR to QUIT", sExit
Application.Terminate
'

$IFDEF NeverDefineMe         ' Results here
    '
	' Tiny Exe : RapidQ32.Dll V109  is the RapidQ interpretor
    ' -------------------------------------------------------
    Empty Loop Time :                          0.656113267  seconds

    Integer Mult Full Loop Time :              1.562863231  seconds
    Integer Mult without Loop For Next Time:   0.906749964  seconds

    Double Mult Full Loop Time :               1.452875018  seconds
    Double Mult without Loop For Next Time:    0.796761751  seconds

    GetTickCount Full Loop Time :              4.297238350  seconds
    GetTickCount without Loop For Next Time:   3.641125083  seconds

    Space$(50)  Full Loop Time :               1.717875004  seconds
    Space$(50)  without Loop For Next Time:    1.061761737  seconds

    Adding Strings Full Loop Time :            3.297101498  seconds
    Adding Strings without Loop For Next Time: 2.640988231  seconds

    Search String Full Loop Time :             2.672226667  seconds
    Search String without Loop For Next Time:  2.016113400  seconds
    '
	' Stand alone  Exe : RapidQCC.Lib V109 is the RapidQ interpretor
    ' --------------------------------------------------------------
    Empty Loop Time :                          1.266101599  seconds

    Integer Mult Full Loop Time :              3.374988317  seconds
    Integer Mult without Loop For Next Time:   2.108886719  seconds

    Double Mult Full Loop Time :               3.343988180  seconds
    Double Mult without Loop For Next Time:    2.077886581  seconds

    GetTickCount Full Loop Time :              6.062238216  seconds
    GetTickCount without Loop For Next Time:   4.796136618  seconds

    Space$(50)  Full Loop Time :               3.250226498  seconds
    Space$(50)  without Loop For Next Time:    1.984124899  seconds

    Adding Strings Full Loop Time :            5.719226360  seconds
    Adding Strings without Loop For Next Time: 4.453124762  seconds

    Search String Full Loop Time :             4.952988148  seconds
    Search String without Loop For Next Time:  3.686886549  seconds

$ENDIF
