'
' -----------------------------------------------------------------------------
' Speed Compare between RapidQ Interpretor in .Dll and in .Lib
' RapidQ Gui Test Code                         	 	 Jacques  October 22th 2010
' -----------------------------------------------------------------------------
'
''pre cmd nocon run exe kill opt DirIcon 'enc upx 'BK 'LaunBas 'output 'adddll
 DefStr sBuildCount    =       "0.012"  ''pre + 0.001 3
''pre end
'
$TypeCheck On
$Escapechars on
$Include "RapidQ.Inc"
$Include "Qredex.Inc"
'
Declare Function GetTickCount Lib "kernel32" Alias "GetTickCount" () As Long
'
Declare Sub OnClose_frmSpeedLibDll
Declare Sub OnClic_AnyMenu (Sender As QMenuItem)
'
Create frmSpeedLibDll As QForm
    Center
    Width = 800
    height = 600
    Caption = "frmSpeedLibDll V" &  sBuildCount
    AutoScroll = False
    OnClose = OnClose_frmSpeedLibDll
    Create rchWin AS QRichEdit
        Align = 5
        Font.Name = "courier"
        Font.Size = 12
		Font.Bold = True
        Font.Color = &H800000
        ReadOnly = True
        WordWrap = False
        ScrollBars = ssBoth
        HideSelection = False
        PlainText = True
        ExtendSizeLimit
    End Create
    Create mnuMain AS QMAINMENU
        Create mnuRUN AS QMENUITEM
            Caption = "&RUN AGAIN"
            OnClick = OnClic_AnyMenu
        End Create
    End Create
End Create
'
' --------------------------------------------------------------------
' New Code API Call that lets RapidQ programs minimize to the task bar
DECLARE FUNCTION SetWindowLong LIB "user32" ALIAS "SetWindowLongA" (hWnd AS LONG, _
                                               nIndex AS LONG, dwNewLong AS LONG) AS LONG
'      ----- API Constants and Functions
CONST GWL_HWNDPARENT = (-8)                   'Minimize to task bar
CONST HWND_DESKTOP = 0
setwindowlong(frmSpeedLibDll.handle, GWL_HWNDPARENT, HWND_DESKTOP)
setwindowlong(application.handle, GWL_HWNDPARENT, frmSpeedLibDll.handle)
' --------------------------------------------------------------------
DefInt flagMenuBusy = False
DefStr sAppDir = Command$(0) - Application.Exename
'
' *************************************
frmSpeedLibDll.Show
' *************************************
'
OnClic_AnyMenu (mnuRUN)
'
' *************************************
frmSpeedLibDll.Visible = False
frmSpeedLibDll.ShowModal
' *************************************
'
Sub OnClose_frmSpeedLibDll
    Application.Terminate
End Sub
'
Sub OnClic_AnyMenu (Sender)
    If flagMenuBusy = True Then Exit Sub
    flagMenuBusy = true
    Select Case Sender.Handle
        Case mnuRun.Handle
			rchWin.Clear
			DoEvents
			DefSng sngChronoRQ
			DefSng sngChronoTotal = Timer
			'
			DefDbl dblArray (0 to 2) = {3.333, 3, 0}
			DefDbl dbl1 = 3.333, dbl2 = 3, dbl3 = 0
			DefInt i1 = 12345, i2 = 54321, i3
			DefStr s1, s2, s3
			'
			DefInt RQ_LoopCount = 1000000           ' adjust this to your computer speed
		'
		' Empty Loops
		' -----------
			DefInt N
			DefSng sngChronoEmptyRQ = Timer
			For N = 1 To RQ_LoopCount
			Next N
			sngChronoEmptyRQ = Timer - sngChronoEmptyRQ
			rchWin.Addstring "    Empty Loop Time :                          " & Str$(sngChronoEmptyRQ) & "  seconds"
            DoEvents
		'
		' Integer Multiplication
		' ----------------------
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
				i3 = i1 * i2
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    Integer Mult Full Loop Time :              " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    Integer Mult without Loop For Next Time:   " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
			'
		' Loop with Double Multiplications
		' --------------------------------
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
		    dbl3 = dbl1 * dbl2
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    Double Mult Full Loop Time :               " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    Double Mult without Loop For Next Time:    " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
		'
		' Api Call GetTickCount
		' ---------------------
			DefInt iGetTickCount
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
	    		iGetTickCount = GetTickCount
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    GetTickCount Full Loop Time :              " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    GetTickCount without Loop For Next Time:   " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
			'
			' Creating String With Space$
			' ---------------------------
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
	    		s1 = Space$(50)
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    Space$(50)  Full Loop Time :               " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    Space$(50)  without Loop For Next Time:    " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
			'
			' Adding Strings
			' --------------
			s1 = "abcdef"
			s2 = "ghijkl"
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
	    		s3 = s1 + s2
		        s3 = ""
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    Adding Strings Full Loop Time :            " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    Adding Strings without Loop For Next Time: " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
			'
			' Search in String
			' ----------------
			s1 = "Rapid-Q is a programming language, a BASIC programming language to be precise. It is multiplatform, although not completely compatible in terms of the graphical interface"
			s2 = "It is"
			sngChronoRQ = Timer
			For N = 1 To RQ_LoopCount
	   			i1 = Instr (s1, s2)
			Next N
			sngChronoRQ = Timer - sngChronoRQ
			rchWin.Addstring
			rchWin.Addstring "    Search String Full Loop Time :             " & Str$(sngChronoRQ) & "  seconds"
			rchWin.Addstring "    Search String without Loop For Next Time:  " & Str$(sngChronoRQ - sngChronoEmptyRQ) & "  seconds"
            DoEvents
			'
			' Total Code and Loops
			' --------------------
			sngChronoTotal = Timer - sngChronoTotal
			rchWin.Addstring
			rchWin.Addstring "Total Time : Code + Loops With For Next Time : " & Str$(sngChronoTotal) & "  seconds"
            DoEvents
			'
            ' FINISHED
			' --------	
			rchWin.Addstring "\n                            ***  FINISHED  ***"
    End Select
    flagMenuBusy = False
End Sub
'
